-- What properties are or were owned simultaniously with property 7797 as
-- is best known
-- Valid-time sequenced and transaction-time current
SELECT P2.property_number, GREATEST( P1.VT_Begin, P2.VT_Begin ) AS VT_Begin,
       LEAST( P1.VT_End, P2.VT_End ) AS VT_End
FROM Prop_Owner P1, Prop_Owner P2
WHERE P1.property_number = 7797
  AND P2.property_number <> P1.property_number
  AND P1.customer_number = P2.customer_number
  AND P1.VT_Begin < P2.VT_End AND P2.VT_Begin < P1.VT_End
  AND P1.TT_Stop = TO_DATE( '12/31/9999', 'MM/DD/YYYY' )
  AND P2.TT_Stop = TO_DATE( '12/31/9999', 'MM/DD/YYYY' );
